LibTransition = LibStub("LibTransition-1.0");
Combustion_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
local lvb,ffb,ignite,pyro1,pyro2,comb,impact
local LBTime,FFBTime,IgnTime,PyroTime,CombustionUp,ffbglyph,combufadeout,impactup
 
function Combustion_OnLoad(CombustionFrame)
	CombustionFrame:RegisterForDrag("LeftButton")
	CombustionFrame:RegisterEvent("PLAYER_LOGIN")
	CombustionFrame:RegisterEvent("PLAYER_TALENT_UPDATE")
	CombustionFrame:RegisterEvent("GLYPH_ADDED")
	CombustionFrame:RegisterEvent("GLYPH_REMOVED")
	CombustionFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
	CombustionFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
 
    lvb = GetSpellInfo(44457) 
    ffb = GetSpellInfo(44614) 
    ignite = GetSpellInfo(12654) 
    pyro1 = GetSpellInfo(11366) 
    pyro2 = GetSpellInfo(92315) 
    comb = GetSpellInfo(11129)   
    impact = GetSpellInfo(64343)
    
    LibTransition:Attach(CombustionFrame)

            	   	
-------------------------------
--Default values    
    if (combuffb == nil) then combuffb = true
    end
    
    if (combuautohide == nil) then combuautohide = false -- set autohide off as default upon very first launch
    end
    
    if (combuimpact == nil) then combuimpact = true -- set impact mode on as default upon very first launch
    end
    
   if (combuscale == nil) then combuscale = 1 -- set impact mode on as default upon very first launch
    end
    
end

-------------------------------
-- helper function for option panel setup
function CombustionHelperOptions_OnLoad(panel)
	panel.name = "CombustionHelper" .. GetAddOnMetadata("CombustionHelper", "Version");
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- lock function for option panel
function Combustionlock()

	if CombulockButton:GetChecked(true) then combulock = true 
                                 CombustionFrame:EnableMouse(false)
                                 CombulockButton:SetChecked(true)
                                 ChatFrame1:AddMessage("|cff00ffffCombustionHelper locked|r")
	else combulock = false 
         CombustionFrame:EnableMouse(true)
         CombulockButton:SetChecked(false)
         ChatFrame1:AddMessage("|cff00ffffCombustionHelper unlocked|r")
	end
end

-------------------------------
-- ffb function for option panel
function Combustionffb()

	if CombuffbButton:GetChecked(true) then combuffb = true 
                                 FFBframeshow()
                                 CombuffbButton:SetChecked(true)
                                 ChatFrame1:AddMessage("|cff00ffffFrostFire Bolt mode enabled|r")
	else combuffb = false 
         FFBframehide()
         CombuffbButton:SetChecked(false)
         ChatFrame1:AddMessage("|cff00ffffFrostFire Bolt mode disabled|r")
	end
end

-------------------------------
-- autohide function for option panel
function Combustionautohide()

	if CombuautohideButton:GetChecked(true) then combuautohide = true 
                                                 CombustionFrame:FadeOut(2);
                                                 CombuautohideButton:SetChecked(true)
                                                 ChatFrame1:AddMessage("|cff00ffffAutohide mode enabled|r")
	else combuautohide = false 
         CombustionFrame:FadeIn(2);
         CombuautohideButton:SetChecked(false)
         ChatFrame1:AddMessage("|cff00ffffAutohide mode disabled|r")
	end
end

-------------------------------
-- impact function for option panel
function Combustionimpact()

	if CombuimpactButton:GetChecked(true) then combuimpact = true 
                                               CombuimpactButton:SetChecked(true)
                                               ChatFrame1:AddMessage("|cff00ffffImpact mode enabled|r")
	else combuimpact = false 
         CombuimpactButton:SetChecked(false)
         ChatFrame1:AddMessage("|cff00ffffImpact mode disabled|r")
	end
end

-------------------------------
-- Scale function for option panel
function CombustionScale (scale)

	CombustionFrame:SetScale(scale)
	combuscale = scale
end

-------------------------------
-- helper function for ffb frames showing
function FFBframeshow()
	
	FFBButtonFrame:Show()
	FFBTextFrame:Show()
	FFB:Show()
	StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-41)
	CombustionFrame:SetHeight(57)
	
end		

-------------------------------
-- helper function for ffb frames hiding
function FFBframehide()
	
	FFBButtonFrame:Hide()
	FFBTextFrame:Hide()
	FFB:Hide()
	StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-32)
	CombustionFrame:SetHeight(48)
	
end		

-------------------------------
-- helper function reset Savedvariables
function Combustionreset ()
 		combulock = nil
        combuffb = nil
        combuautohide = nil
        combuimpact = nil
        combuscale = 1
		ChatFrame1:AddMessage("|cff00ffffCombustionHelper Savedvariables have been resetted, you can logout now.|r")

end
 
function Combustion_OnEvent(self, event, ...)

    if (event == "PLAYER_LOGIN") then
    
    CombustionScale (combuscale)
    
-------------------------------
--Startup message
    if (combuautohide == true) and (combuimpact == false)
    then ChatFrame1:AddMessage("|cff00ffffCombustion Helper is loaded. Interface Panel -> Addons for Config.|r")
    	 ChatFrame1:AddMessage("|cff00ffffAutoHide is on, hidden when combustion on cd or out of combat|r")
    elseif (combuautohide == true) and (combuimpact == true)
    then ChatFrame1:AddMessage("|cff00ffffCombustion Helper is loaded. Interface Panel -> Addons for Config.|r")
    	 ChatFrame1:AddMessage("|cff00ffffImpact mode is on, Autohide disabled when in combat|r")
    elseif (combuautohide == false) and (combuimpact == true)
   	then ChatFrame1:AddMessage("|cff00ffffCombustion Helper is loaded. Interface Panel -> Addons for Config.|r")
	     ChatFrame1:AddMessage("|cff00ffffAutohide disabled, Impact mode is on|r")
    elseif (combuautohide == false) and (combuimpact == false)
   	then ChatFrame1:AddMessage("|cff00ffffCombustion Helper is loaded. Interface Panel -> Addons for Config.|r")
	     ChatFrame1:AddMessage("|cff00ffffAutohide disabled, Impact mode is off|r")	
	end
    
-------------------------------
--Combustion spell check on startup    
        local a6 = IsSpellKnown(11129) -- check if combustion is in the spellbook
                
        if (a6 == false) 
        then CombustionFrame:FadeOut(2)
             combutalent = false

        elseif (a6 == true) 
        then CombustionFrame:FadeIn(2)
             combutalent = true

        end
        
-------------------------------
--frostfirebolt glyph check on startup
        local enabled1,_,_,id1 = GetGlyphSocketInfo(1)
        local enabled4,_,_,id4 = GetGlyphSocketInfo(4)
        local enabled6,_,_,id6 = GetGlyphSocketInfo(6)
         
	            if (id1 == 61205) or (id4 == 61205) or (id6 == 61205)
	            then ffbglyph = true
    	       		 FFBframeshow()

	            else ffbglyph = false
                     combuffb = false
                     FFBframehide()

            	end 
                
-------------------------------
--Frame lock check on startup
        if (combulock == false) 
        then CombustionFrame:EnableMouse(true)
        
        elseif (combulock == true) 
        then CombustionFrame:EnableMouse(false)
        
        end	
            
-------------------------------
--autohide check on startup
        if (combuautohide == true) 
        then CombustionFrame:FadeOut(2)
 
        end	
        
-------------------------------
--ffb mode check on startup
        if (combuffb == true) then FFBframeshow()
        elseif (combuffb == false) then FFBframehide()

        end	    

end

    if (event == "PLAYER_TALENT_UPDATE") then
-------------------------------
--Combustion spell check            
            local a6 = IsSpellKnown(11129) -- check if combustion is in the spellbook
                
            if (a6 == false) and (combutalent == true) then
                    CombustionFrame:FadeOut(2)
                    combutalent = false
                    ChatFrame1:AddMessage("|cff00ffffNo Combustion spell in Spellbook, CombustionHelper hiding now.|r")
            elseif (a6 == true) and (combutalent == false) then
                    CombustionFrame:FadeIn(2)
                    combutalent = true
                    ChatFrame1:AddMessage("|cff00ffffCombustion spell in Spellbook, CombustionHelper back in.|r")
            end

    end
    
-------------------------------
--frostfirebolt glyph check
    if (event == "GLYPH_ADDED") or (event == "GLYPH_REMOVED") then

        local enabled1,_,_,id1 = GetGlyphSocketInfo(1)
        local enabled4,_,_,id4 = GetGlyphSocketInfo(4)
        local enabled6,_,_,id6 = GetGlyphSocketInfo(6)
         
	            if (id1 == 61205) and (ffbglyph == false) and (combutalent == true) and (combuffb == true)
	            then ffbglyph = true
    	       		 FFBframeshow()
	                 ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt glyph detected, FFB mode enabled|r")
	            
	            elseif (id4 == 61205) and (ffbglyph == false) and (combutalent == true) and (combuffb == true)
	            then ffbglyph = true
    	       		 FFBframeshow()
	                 ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt glyph detected, FFB mode enabled|r")
	            
	            elseif (id6 == 61205) and (ffbglyph == false) and (combutalent == true) and (combuffb == true)
	            then ffbglyph = true
    	       		 FFBframeshow()
	                 ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt glyph detected, FFB mode enabled|r")
				
				elseif (id1 ~= 61205) and (id4 ~= 61205) and (id6 ~= 61205) and (ffbglyph == true) and (combutalent == true)
				then ffbglyph = false
					 FFBframehide()
	                 ChatFrame1:AddMessage("|cff00ffff No Frostfire Bolt glyph detected, FFB mode disabled|r")
	            
	            elseif (ffbglyph == false)
	            then FFBframehide()

            	end 
			 	
    end
    
-------------------------------
--in and out of combat check  
    if (event == "PLAYER_REGEN_DISABLED") and (combuautohide == true) and (combutalent == true)-- autoshow when in combat
        then CombustionFrame:FadeIn(2)
    elseif (event == "PLAYER_REGEN_ENABLED") and (combuautohide == true)  and (combutalent == true)-- autohide when out of combat
        then CombustionFrame:FadeOut(3)
    elseif (event == "ADDON_LOADED" and ... == "CombustionHelper") and (combuautohide == true) and (combutalent == true)
        then CombustionFrame:FadeOut(3)
    end
-------------------------------
end

function Combustion_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
 
		if (self.TimeSinceLastUpdate > Combustion_UpdateInterval) then
            local time = GetTime()   
-------------------------------
--Living Bomb part
			local a,b,c,d,e,f,g,h,i,j,k = UnitAura("target", lvb, nil, "PLAYER HARMFUL")		

			if (k==44457) and ((-1*(time-g))>=2) -- condition when timer is with more than 2 seconds left
			then LBTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g)))
			     LBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 LBTime = 1

			elseif (k==44457) and ((-1*(time-g))<=2) -- condition when timer is with less than 2 seconds left
			then LBTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g)))
			     LBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 LBTime = 0

			else LBTextFrameLabel:SetText(format("|cffff0000LB|r")) 
			     LBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
                 LBTime = 0
			end
--------------------------------
--FrostfireBolt part
			local a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1 = UnitAura("target", ffb, nil, "PLAYER HARMFUL")		

			if (ffbglyph == false) or (combuffb == false)
			then FFBTime = 1
            	 FFBTextFrameLabel:SetText(format("|cffff0000Glyph|r"))
			
			elseif (k1==44614) and ((-1*(time-g1))>=2) -- condition when timer is with more than 2 seconds left
			then FFBTextFrameLabel:SetText(format("|cff00ff00%.1f/%d|r",-1*(time-g1),(d1)))
			     FFBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 FFBTime = 1

			elseif (k1==44614) and ((-1*(time-g1))<=2) -- condition when timer is with less than 2 seconds left
			then FFBTextFrameLabel:SetText(format("|cffff0000%.1f/%d|r",-1*(time-g1),(d1)))
			     FFBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 FFBTime = 0

			else FFBTextFrameLabel:SetText(format("|cffff0000FFB|r"))
			     FFBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
                 FFBTime = 0
			end
--------------------------------
--Ignite part
			local a2,b2,c2,d2,e2,f2,g2,h2,i2,j2,k2 = UnitAura("target", ignite, nil, "PLAYER HARMFUL")		

			if (k2==12654) and ((-1*(time-g2))>=2) -- condition when timer is with more than 2 seconds left
			then IgnTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g2)))
			     IgniteButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 IgnTime = 1

			elseif (k2==12654) and ((-1*(time-g2))<=2) -- condition when timer is with less than 2 seconds left
			then IgnTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g2)))
			     IgniteButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 IgnTime = 0

			else IgnTextFrameLabel:SetText(format("|cffff0000Ign|r"))
			     IgniteButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
                 IgnTime = 0
			end
--------------------------------
--Pyroblast part
			local a3,b3,c3,d3,e3,f3,g3,h3,i3,j3,k3 = UnitAura("target", pyro1, nil, "PLAYER HARMFUL")		
			local a4,b4,c4,d4,e4,f4,g4,h4,i4,j4,k4 = UnitAura("target", pyro2, nil, "PLAYER HARMFUL")		

			if (k3==11366) and ((-1*(time-g3))>=2) -- condition when timer is with more than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g3)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 1
                 
			elseif (k4==92315) and ((-1*(time-g4))>=2) -- condition when timer is with more than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g4)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 1

			elseif (k3==11366) and ((-1*(time-g3))<=2) -- condition when timer is with less than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g3)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 0

			elseif (k4==92315) and ((-1*(time-g4))<=2) -- condition when timer is with less than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g4)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 0

            else PyroTextFrameLabel:SetText(format("|cffff0000Pyro|r"))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
			     PyroTime = 0
            end
--------------------------------
--Combustion/impact part            
			local a5,b5,c5 = GetSpellCooldown(comb)
			local a7,b7,c7,d7,e7,f7,g7,h7,i7,j7,k7 = UnitAura("player", impact)
					
			if (b5 == nil) then
            
			elseif (b5<=2) -- condition when combustion cd is up, taking gcd in account
			then StatusTextFrameLabel:SetText(format("Combustion Up !"))
				 CombustionUp = 1
				 ImpactUp = 0
				 combufadeout = false

			elseif (b5>=2) and (k7 == 64343) and (combuimpact == true)-- condition when impact is up and combustion in cd
			then StatusTextFrameLabel:SetText(format("|cff00ff00Impact Up for %.1f !!|r",-1*(time-g7)))
				 CombustionUp = 0
				 ImpactUp = 1
				 combufadeout = false

 			elseif ((a5 + b5 - time)>=60) and (combufadeout == false) and (k7 == nil) -- timer for combustion in minutes
            then StatusTextFrameLabel:SetText(format("Combustion in %d:%0.2d",(a5 + b5 - time) / 60,(a5 + b5 - time) % 60 ))  
				 CombustionUp = 0
				 ImpactUp = 0
                 
 			elseif ((a5 + b5 - time)<=60) and (k7 == nil)
            then StatusTextFrameLabel:SetText(format("Combustion in %.0fsec",(a5 + b5 - time)))  -- timer for combustion in seconds
				 CombustionUp = 0	
				 ImpactUp = 0
				
			end
--------------------------------
            if (LBTime == 1) 
                and (FFBTime == 1) 
                and (IgnTime == 1) 
                and (PyroTime == 1) 
                and (CombustionUp == 1)
                then CombustionFrame:SetBackdropColor(0,0.7,0) --Green background for frame when dots and combustion are up
            elseif (LBTime == 1) 
                and (FFBTime == 1) 
                and (IgnTime == 1) 
                and (PyroTime == 1) 
                and (ImpactUp == 1)
                and (CombustionUp == 0) --Yellow background for frame when dots and Impact are up
                then CombustionFrame:SetBackdropColor(1,0.82,0.5)
            else CombustionFrame:SetBackdropColor(0.25,0.25,0.25)
            end
--------------------------------
 -- autohide part 
 			if (a5 == nil) then
			elseif ((a5 + b5 - time) <= 105) 
			   and ((a5 + b5 - time) >= 18) 
			   and (combufadeout == false) 
			   and (combuautohide == true) 
			   and (combuimpact == false) 
			   then combufadeout = true
	             	StatusTextFrameLabel:SetText(format("Autohiding now."))
				    CombustionFrame:FadeOut(3);
				    CombustionFrame:Wait(86);
				    CombustionFrame:FadeIn(2);
			end
--------------------------------
		self.TimeSinceLastUpdate = 0

    end    
end


SLASH_COMBUCONFIG1 = "/combustionhelper"

SlashCmdList["COMBUCONFIG"] = function(msg)
	if msg=="lock" then
		combulock = true
		CombustionFrame:EnableMouse(false)
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is locked|r")

	elseif msg=="unlock" then
		combulock = false
		CombustionFrame:EnableMouse(true)
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is unlocked|r")

	elseif msg=="ffbon" then
		combuffb = true
		ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt enabled|r")
		FFBframeshow()
		
	elseif msg=="ffboff" then
		combuffb = false
		ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt disabled|r")
		FFBframehide()
				
	elseif msg=="hide" then
 		combutalent = false
        CombustionFrame:FadeOut(2);
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is hidden now|r")

	elseif msg=="show" then
 		combutalent = true
        CombustionFrame:FadeIn(2);
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is showing now|r")
		
	elseif msg=="autohideoff" then
 		combuautohide = false
        CombustionFrame:FadeIn(2);
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper autohide off|r")		

	elseif msg=="autohideon" then
 		combuautohide = true
        CombustionFrame:FadeOut(2);
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper autohide on|r")
							
	elseif msg=="impactoff" then
 		combuimpact = false
		ChatFrame1:AddMessage("|cff00ffffImpact mode off|r")		

	elseif msg=="impacton" then
 		combuimpact = true
		ChatFrame1:AddMessage("|cff00ffffImpact mode on|r")

--~ 	elseif msg=="reset" then
--~  		Combureset()
		
    elseif msg == "" or  msg == "help" or  msg == "?" then
		ChatFrame1:AddMessage("/combustionhelper lock |cffffff00- Lock Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper unlock |cffffff00- Unlock Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper ffbon |cffffff00- Enable Frostfire Bolt|r")
		ChatFrame1:AddMessage("/combustionhelper ffboff |cffffff00- Disable Frostfire Bolt|r")
		ChatFrame1:AddMessage("/combustionhelper hide |cffffff00- Hide Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper show |cffffff00- Show Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper autohideon |cffffff00- Enable Combustion Helper autohide|r")
		ChatFrame1:AddMessage("/combustionhelper autohideoff |cffffff00- Disable Combustion Helper autohide|r")
		ChatFrame1:AddMessage("/combustionhelper impacton |cffffff00- Enable Impact mode|r")
		ChatFrame1:AddMessage("/combustionhelper impactoff |cffffff00- Disable Impact mode|r")
		ChatFrame1:AddMessage("/combustionhelper reset |cffffff00- Combustionhelper Savedvariables have been reset, logout now for clean restart|r")
		ChatFrame1:AddMessage("|cffffff00- For Scale settings, go to Interface Panel -> Addons|r")
		
	else
		ChatFrame1:AddMessage("|cffffff00CombustionHelper: Unknown command, type '/combustionhelper' for help.|r")
	end

end